<template>
  <div>
      
            <v-card class="mx-auto mb-10"
                max-width="300px" >
                <v-img
                    v-if="getBookDetailById.volumeInfo.imageLinks"
                    :src="getBookDetailById.volumeInfo.imageLinks.thumbnail"
                    
                    height="auto"
                    min-height="300px"
                    contain
                    class="grey"
                    width="100%"
                    
                    >
                        <template v-slot:placeholder >
                            <v-row
                                class="fill-height ma-0"
                                align="center"
                                justify="center"
                            
                            >
                                <v-progress-circular
                                indeterminate
                                color="grey lighten-5"
                                v-if="getBookDetailById.volumeInfo.imageLinks.thumbnail"></v-progress-circular>
                                <span v-else>NO IMAGE</span>
                            </v-row>
                        </template>
                    <!-- <span 
                        class="headline white--text pl-4 pt-4 d-inline-block"
                        v-text="card"
                    >What?</span> -->
                </v-img>
                <div v-else class="no-img"><span>NO IMAGE</span></div>
                
                <favorite-btn :bookid="getBookDetailById.id" :booktitle="getBookDetailById.volumeInfo.title" :bookcoverimage="getBookDetailById.volumeInfo.imageLinks?getBookDetailById.volumeInfo.imageLinks.thumbnail:''"></favorite-btn>
                    
            </v-card>
            <div>
                
                <div class="my-8" v-if="getBookDetailById.saleInfo.listPrice">{{getBookDetailById.saleInfo.listPrice.amount}} {{getBookDetailById.saleInfo.listPrice.currencyCode}}</div>
                <div class="my-8" v-else>FREE</div>
            
                <v-btn color="primary" width="100px" :href="getBookDetailById.saleInfo.buyLink" class="mb-5">buy now</v-btn>
                
            </div>
        <v-row>
          <v-col class="" cols="12"> 
              <div class="text-center mb-5">
                  <h2>{{getBookDetailById.volumeInfo.title}}</h2>
              </div>
              <div class="text-left" v-if="getBookDetailById.volumeInfo.authors">
                  <label class="mr-10" >Author: {{getBookDetailById.volumeInfo.authors[0]}}</label> 
              </div>
              <div class="text-left">
                  <label>Publisher: {{getBookDetailById.volumeInfo.publisher}}</label>
              </div>
              <div class="text-left">
                  <label>Page count: {{getBookDetailById.volumeInfo.pageCount}} pages</label>
              </div>
             
              <hr>
              <div class="text-left mt-5 text-description" v-if="getBookDetailById.volumeInfo.description">
                  <label >Description</label>
                  <p class="my-5" v-html="getBookDetailById.volumeInfo.description"></p>
              </div>
          </v-col>
      </v-row>
  </div>
</template>

<script>
import FavoriteBtn from '@/components/FavoriteBtn.vue'
import {mapActions, mapGetters} from 'vuex'
export default {
    components:{
        FavoriteBtn
    },
    computed:{
        ...mapGetters([
            'getBookDetailById',
            'getFavoriteBook'
        ])
    },
    methods:{
        ...mapActions([
            'fetchBookById'
        ])
    },
    created(){
        this.fetchBookById({bookid:this.$route.params.id})
    }
}
</script>

<style>
.text-description label{
    font-weight: bold;
    font-size: 1.25rem;
}
.no-img{
    height:300px;
    background:#c2c2c2;
    display: flex;
    flex-direction: row;
    align-items: center;
    justify-content: center;
}
</style>
